diff --git a/example/generator/odp_generator.c b/example/generator/odp_generator.c
index ed5396d..38cf4b9 100644
--- a/example/generator/odp_generator.c
+++ b/example/generator/odp_generator.c
@@ -308,7 +308,8 @@ static odp_pktio_t create_pktio(const char *dev, odp_pool_t pool)
 	qparam.sched.prio  = ODP_SCHED_PRIO_DEFAULT;
 	qparam.sched.sync  = ODP_SCHED_SYNC_ATOMIC;
 	qparam.sched.group = ODP_SCHED_GROUP_DEFAULT;
-	snprintf(inq_name, sizeof(inq_name), "%i-pktio_inq_def", (int)pktio);
+	snprintf(inq_name, sizeof(inq_name), "%" PRIu64 "-pktio_inq_def",
+		 odp_pktio_t_print(pktio));
 	inq_name[ODP_QUEUE_NAME_LEN - 1] = '\0';
 
 	inq_def = odp_queue_create(inq_name, ODP_QUEUE_TYPE_PKTIN, &qparam);
@@ -319,9 +320,11 @@ static odp_pktio_t create_pktio(const char *dev, odp_pool_t pool)
 	if (ret != 0)
 		EXAMPLE_ABORT("Error: default input-Q setup for %s\n", dev);
 
-	printf("  created pktio:%02i, dev:%s, queue mode (ATOMIC queues)\n"
-	       "          default pktio%02i-INPUT queue:%u\n",
-		pktio, dev, pktio, inq_def);
+	printf("  created pktio:%02" PRIu64
+	       ", dev:%s, queue mode (ATOMIC queues)\n"
+	       "          default pktio%02" PRIu64 "-INPUT queue:%u\n",
+	       odp_pktio_t_print(pktio), dev,
+	       odp_pktio_t_print(pktio), inq_def);
 
 	return pktio;
 }
diff --git a/example/ipsec/odp_ipsec.c b/example/ipsec/odp_ipsec.c
index a4dc63d..5b1c703 100644
--- a/example/ipsec/odp_ipsec.c
+++ b/example/ipsec/odp_ipsec.c
@@ -567,7 +567,8 @@ void initialize_intf(char *intf)
 	qparam.sched.prio  = ODP_SCHED_PRIO_DEFAULT;
 	qparam.sched.sync  = ODP_SCHED_SYNC_ATOMIC;
 	qparam.sched.group = ODP_SCHED_GROUP_DEFAULT;
-	snprintf(inq_name, sizeof(inq_name), "%i-pktio_inq_def", (int)pktio);
+	snprintf(inq_name, sizeof(inq_name), "%" PRIu64 "-pktio_inq_def",
+		 odp_pktio_t_print(pktio));
 	inq_name[ODP_QUEUE_NAME_LEN - 1] = '\0';
 
 	inq_def = QUEUE_CREATE(inq_name, ODP_QUEUE_TYPE_PKTIN, &qparam);
@@ -595,10 +596,11 @@ void initialize_intf(char *intf)
 		exit(EXIT_FAILURE);
 	}
 
-	printf("Created pktio:%02i, queue mode (ATOMIC queues)\n"
-	       "          default pktio%02i-INPUT queue:%u\n"
+	printf("Created pktio:%02" PRIu64 ", queue mode (ATOMIC queues)\n"
+	       "          default pktio%02" PRIu64 "-INPUT queue:%u\n"
 	       "          source mac address %s\n",
-	       pktio, pktio, inq_def, mac_addr_str(src_mac_str, src_mac));
+	       odp_pktio_t_print(pktio), odp_pktio_t_print(pktio), inq_def,
+	       mac_addr_str(src_mac_str, src_mac));
 
 	/* Resolve any routes using this interface for output */
 	resolve_fwd_db(intf, outq_def, src_mac);
diff --git a/example/l2fwd/odp_l2fwd.c b/example/l2fwd/odp_l2fwd.c
index 195d3d0..0e997a2 100644
--- a/example/l2fwd/odp_l2fwd.c
+++ b/example/l2fwd/odp_l2fwd.c
@@ -196,11 +196,12 @@ static void *pktio_ifburst_thread(void *arg)
 	pktio_src = gbl_args->pktios[src_idx];
 	pktio_dst = gbl_args->pktios[dst_idx];
 
-	printf("[%02i] srcif:%s dstif:%s spktio:%02i dpktio:%02i BURST mode\n",
+	printf("[%02i] srcif:%s dstif:%s spktio:%02" PRIu64
+	       " dpktio:%02" PRIu64 " BURST mode\n",
 	       thr,
 	       gbl_args->appl.if_names[src_idx],
 	       gbl_args->appl.if_names[dst_idx],
-	       pktio_src, pktio_dst);
+	       odp_pktio_t_print(pktio_src), odp_pktio_t_print(pktio_dst));
 
 	/* Loop packets */
 	for (;;) {
@@ -253,7 +254,8 @@ static odp_pktio_t create_pktio(const char *dev, odp_pool_t pool,
 		return ODP_PKTIO_INVALID;
 	}
 
-	printf("created pktio %d (%s)\n", pktio, dev);
+	printf("created pktio %" PRIu64 " (%s)\n",
+	       odp_pktio_t_print(pktio), dev);
 
 	/* no further setup needed for burst mode */
 	if (mode == APPL_MODE_PKT_BURST)
@@ -262,7 +264,8 @@ static odp_pktio_t create_pktio(const char *dev, odp_pool_t pool,
 	qparam.sched.prio  = ODP_SCHED_PRIO_DEFAULT;
 	qparam.sched.sync  = ODP_SCHED_SYNC_ATOMIC;
 	qparam.sched.group = ODP_SCHED_GROUP_DEFAULT;
-	snprintf(inq_name, sizeof(inq_name), "%i-pktio_inq_def", (int)pktio);
+	snprintf(inq_name, sizeof(inq_name), "%" PRIu64 "-pktio_inq_def",
+		 odp_pktio_t_print(pktio));
 	inq_name[ODP_QUEUE_NAME_LEN - 1] = '\0';
 
 	inq_def = odp_queue_create(inq_name, ODP_QUEUE_TYPE_PKTIN, &qparam);
diff --git a/example/packet/odp_pktio.c b/example/packet/odp_pktio.c
index 83992b6..c596ad1 100644
--- a/example/packet/odp_pktio.c
+++ b/example/packet/odp_pktio.c
@@ -120,7 +120,8 @@ static odp_pktio_t create_pktio(const char *dev, odp_pool_t pool, int mode)
 	qparam.sched.prio  = ODP_SCHED_PRIO_DEFAULT;
 	qparam.sched.sync  = ODP_SCHED_SYNC_ATOMIC;
 	qparam.sched.group = ODP_SCHED_GROUP_DEFAULT;
-	snprintf(inq_name, sizeof(inq_name), "%i-pktio_inq_def", (int)pktio);
+	snprintf(inq_name, sizeof(inq_name), "%" PRIu64 "-pktio_inq_def",
+		 odp_pktio_t_print(pktio));
 	inq_name[ODP_QUEUE_NAME_LEN - 1] = '\0';
 
 	inq_def = odp_queue_create(inq_name, ODP_QUEUE_TYPE_PKTIN, &qparam);
@@ -131,9 +132,11 @@ static odp_pktio_t create_pktio(const char *dev, odp_pool_t pool, int mode)
 	if (ret != 0)
 		EXAMPLE_ABORT("Error: default input-Q setup for %s\n", dev);
 
-	printf("  created pktio:%02i, dev:%s, queue mode (ATOMIC queues)\n"
-	       "  \tdefault pktio%02i-INPUT queue:%u\n",
-		pktio, dev, pktio, inq_def);
+	printf("  created pktio:%02" PRIu64
+	       ", dev:%s, queue mode (ATOMIC queues)\n"
+	       "  \tdefault pktio%02" PRIu64 "-INPUT queue:%u\n",
+	       odp_pktio_t_print(pktio), dev,
+	       odp_pktio_t_print(pktio), inq_def);
 
 	return pktio;
 }
@@ -164,9 +167,11 @@ static void *pktio_queue_thread(void *arg)
 		return NULL;
 	}
 
-	printf("  [%02i] looked up pktio:%02i, queue mode (ATOMIC queues)\n"
-	       "         default pktio%02i-INPUT queue:%u\n",
-	       thr, pktio, pktio, odp_pktio_inq_getdef(pktio));
+	printf("  [%02i] looked up pktio:%02" PRIu64
+	       ", queue mode (ATOMIC queues)\n"
+	       "         default pktio%02" PRIu64 "-INPUT queue:%u\n",
+	       thr, odp_pktio_t_print(pktio), odp_pktio_t_print(pktio),
+	       odp_pktio_inq_getdef(pktio));
 
 	/* Loop packets */
 	for (;;) {
@@ -241,7 +246,8 @@ static void *pktio_ifburst_thread(void *arg)
 		return NULL;
 	}
 
-	printf("  [%02i] looked up pktio:%02i, burst mode\n", thr, pktio);
+	printf("  [%02i] looked up pktio:%02" PRIu64 ", burst mode\n",
+	       thr, odp_pktio_t_print(pktio));
 
 	/* Loop packets */
 	for (;;) {
diff --git a/include/odp/api/packet_io.h b/include/odp/api/packet_io.h
index da7bc3f..31b3a36 100644
--- a/include/odp/api/packet_io.h
+++ b/include/odp/api/packet_io.h
@@ -232,6 +232,18 @@ int odp_pktio_skip_set(odp_pktio_t pktio_in, uint32_t offset);
  */
 int odp_pktio_headroom_set(odp_pktio_t pktio_in, uint32_t headroom);
 
+/**
+ * Get printable value for an odp_pktio_t
+ *
+ * @param hdl  odp_pktio_t handle to be printed
+ * @return     uint64_t value that can be used to print/display this
+ *             handle
+ *
+ * @note This routine is intended to be used for diagnostic purposes
+ * to enable applications to generate a printable value that represents
+ * an odp_pktio_t handle.
+ */
+uint64_t odp_pktio_t_print(odp_pktio_t hdl);
 
 /**
  * @}
diff --git a/platform/linux-generic/include/odp/plat/packet_io_types.h b/platform/linux-generic/include/odp/plat/packet_io_types.h
index a6bbacf..cc57cec 100644
--- a/platform/linux-generic/include/odp/plat/packet_io_types.h
+++ b/platform/linux-generic/include/odp/plat/packet_io_types.h
@@ -18,16 +18,25 @@
 extern "C" {
 #endif
 
+#include <odp/std_types.h>
+#include <odp/plat/strong_types.h>
+
 /** @addtogroup odp_packet_io ODP PACKET IO
  *  Operations on a packet.
  *  @{
  */
 
-typedef uint32_t odp_pktio_t;
+typedef odp_handle_t odp_pktio_t;
+
+#define ODP_PKTIO_INVALID _odp_cast_scalar(odp_pktio_t, 0)
 
-#define ODP_PKTIO_INVALID 0
+#define ODP_PKTIO_ANY _odp_cast_scalar(odp_pktio_t, ~0)
 
-#define ODP_PKTIO_ANY ((odp_pktio_t)~0)
+/** Get printable format of odp_pktio_t */
+static inline uint64_t odp_pktio_t_print(odp_pktio_t hdl)
+{
+	return _odp_pri(hdl);
+}
 
 /**
  * @}
diff --git a/platform/linux-generic/include/odp_packet_io_internal.h b/platform/linux-generic/include/odp_packet_io_internal.h
index 488818c..47b8992 100644
--- a/platform/linux-generic/include/odp_packet_io_internal.h
+++ b/platform/linux-generic/include/odp_packet_io_internal.h
@@ -68,10 +68,10 @@ extern void *pktio_entry_ptr[];
 static inline pktio_entry_t *get_pktio_entry(odp_pktio_t id)
 {
 	if (odp_unlikely(id == ODP_PKTIO_INVALID ||
-			 id > ODP_CONFIG_PKTIO_ENTRIES))
+			 _odp_typeval(id) > ODP_CONFIG_PKTIO_ENTRIES))
 		return NULL;
 
-	return pktio_entry_ptr[id - 1];
+	return pktio_entry_ptr[_odp_typeval(id) - 1];
 }
 #ifdef __cplusplus
 }
diff --git a/platform/linux-generic/odp_packet.c b/platform/linux-generic/odp_packet.c
index f24dc43..fbe375c 100644
--- a/platform/linux-generic/odp_packet.c
+++ b/platform/linux-generic/odp_packet.c
@@ -572,7 +572,8 @@ void odp_packet_print(odp_packet_t pkt)
 	len += snprintf(&str[len], n-len,
 			"  frame_len    %u\n", hdr->frame_len);
 	len += snprintf(&str[len], n-len,
-			"  input        %u\n", hdr->input);
+			"  input        %" PRIu64 "\n",
+			odp_pktio_t_print(hdr->input));
 	str[len] = '\0';
 
 	ODP_PRINT("\n%s\n", str);
diff --git a/platform/linux-generic/odp_packet_io.c b/platform/linux-generic/odp_packet_io.c
index bdb690e..8e2c6b2 100644
--- a/platform/linux-generic/odp_packet_io.c
+++ b/platform/linux-generic/odp_packet_io.c
@@ -73,7 +73,7 @@ int odp_pktio_init_global(void)
 		pktio_entry->s.outq_default = qid;
 
 		queue_entry = queue_to_qentry(qid);
-		queue_entry->s.pktout = id;
+		queue_entry->s.pktout = _odp_cast_scalar(odp_pktio_t, id);
 	}
 
 	return 0;
@@ -146,7 +146,7 @@ static odp_pktio_t alloc_lock_pktio_entry(void)
 			lock_entry_classifier(entry);
 			if (is_free(entry)) {
 				init_pktio_entry(entry);
-				id = i + 1;
+				id = _odp_cast_scalar(odp_pktio_t, i + 1);
 				return id; /* return with entry locked! */
 			}
 			unlock_entry_classifier(entry);
@@ -205,7 +205,8 @@ static int init_loop(pktio_entry_t *entry, odp_pktio_t id)
 	char loopq_name[ODP_QUEUE_NAME_LEN];
 
 	entry->s.type = ODP_PKTIO_TYPE_LOOPBACK;
-	snprintf(loopq_name, sizeof(loopq_name), "%i-pktio_loopq", (int)id);
+	snprintf(loopq_name, sizeof(loopq_name), "%" PRIu64 "-pktio_loopq",
+		 odp_pktio_t_print(id));
 	entry->s.loopq = odp_queue_create(loopq_name,
 					  ODP_QUEUE_TYPE_POLL, NULL);
 
@@ -319,7 +320,7 @@ odp_pktio_t odp_pktio_lookup(const char *dev)
 	odp_spinlock_lock(&pktio_tbl->lock);
 
 	for (i = 1; i <= ODP_CONFIG_PKTIO_ENTRIES; ++i) {
-		entry = get_pktio_entry(i);
+		entry = get_pktio_entry(_odp_cast_scalar(odp_pktio_t, i));
 		if (is_free(entry))
 			continue;
 
@@ -327,7 +328,7 @@ odp_pktio_t odp_pktio_lookup(const char *dev)
 
 		if (!is_free(entry) &&
 		    strncmp(entry->s.name, dev, IFNAMSIZ) == 0)
-			id = i;
+			id = _odp_cast_scalar(odp_pktio_t, i);
 
 		unlock_entry(entry);
 
diff --git a/test/validation/odp_pktio.c b/test/validation/odp_pktio.c
index 371db42..8d73f6b 100644
--- a/test/validation/odp_pktio.c
+++ b/test/validation/odp_pktio.c
@@ -234,7 +234,8 @@ static int create_inq(odp_pktio_t pktio)
 	qparam.sched.sync  = ODP_SCHED_SYNC_ATOMIC;
 	qparam.sched.group = ODP_SCHED_GROUP_DEFAULT;
 
-	snprintf(inq_name, sizeof(inq_name), "inq-pktio-%d", pktio);
+	snprintf(inq_name, sizeof(inq_name), "inq-pktio-%" PRIu64,
+		 odp_pktio_t_print(pktio));
 	inq_def = odp_queue_lookup(inq_name);
 	if (inq_def == ODP_QUEUE_INVALID)
 		inq_def = odp_queue_create(inq_name,